package DSM;

import java.util.HashSet;
import java.util.Set;

public class PolyUtil {

	public static Poly subtract(Poly a, Poly b) {
		Poly c = a.deepCopy();
		Poly d = b.deepCopy();
		d.multiplyByConstant(-1);
		c.addPoly(d);
		return c;
	}

	public static Set<Set<Poly>> negationOf(Set<Poly> phi) {
		Set<Set<Poly>> ans = new HashSet<>();
		
		for(Poly p:phi)
		{
			Set<Poly> negP = new HashSet<>();
			
			Poly revP = p.deepCopy(); 
			revP.multiplyByConstant(-1);
			
			PolyTerm negativeOneTerm = new PolyTerm();
			negativeOneTerm.constant = -1;
			
			
			revP.addTerm(negativeOneTerm);
			
			negP.add(revP);
			
			ans.add(negP);
		}
		
		return ans;
	}

}
